﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace MartEdit
{
    public partial class Form1 : Form
    {
        int[,] data = new int[650, 21];
        string[] filepaths = new string[650];
        bool filling = true;
        MemoryStream bin = new MemoryStream(0);

        public Form1()
        {
            InitializeComponent(); 
            InitializeFields();
            B_Save.Enabled = false;
            C_Species.Enabled = false;
            L_Moves.Visible = false;
        }

        private int getspecies()
        {
            int species = 0;
            try { species = ToInt32(C_Species.SelectedValue.ToString()); }
            catch { };
            return species;
        }

        private void InitializeFields()
        {
            var species_list = new[] {
                    new { Text = "", Value = 0  },
                    new { Text = "Abomasnow", Value = 460  },
                    new { Text = "Abra", Value = 63  },
                    new { Text = "Absol", Value = 359  },
                    new { Text = "Accelgor", Value = 617  },
                    new { Text = "Aerodactyl", Value = 142  },
                    new { Text = "Aggron", Value = 306  },
                    new { Text = "Aipom", Value = 190  },
                    new { Text = "Alakazam", Value = 65  },
                    new { Text = "Alomomola", Value = 594  },
                    new { Text = "Altaria", Value = 334  },
                    new { Text = "Ambipom", Value = 424  },
                    new { Text = "Amoonguss", Value = 591  },
                    new { Text = "Ampharos", Value = 181  },
                    new { Text = "Anorith", Value = 347  },
                    new { Text = "Arbok", Value = 24  },
                    new { Text = "Arcanine", Value = 59  },
                    new { Text = "Arceus", Value = 493  },
                    new { Text = "Archen", Value = 566  },
                    new { Text = "Archeops", Value = 567  },
                    new { Text = "Ariados", Value = 168  },
                    new { Text = "Armaldo", Value = 348  },
                    new { Text = "Aron", Value = 304  },
                    new { Text = "Articuno", Value = 144  },
                    new { Text = "Audino", Value = 531  },
                    new { Text = "Axew", Value = 610  },
                    new { Text = "Azelf", Value = 482  },
                    new { Text = "Azumarill", Value = 184  },
                    new { Text = "Azurill", Value = 298  },
                    new { Text = "Bagon", Value = 371  },
                    new { Text = "Baltoy", Value = 343  },
                    new { Text = "Banette", Value = 354  },
                    new { Text = "Barboach", Value = 339  },
                    new { Text = "Basculin", Value = 550  },
                    new { Text = "Bastiodon", Value = 411  },
                    new { Text = "Bayleef", Value = 153  },
                    new { Text = "Beartic", Value = 614  },
                    new { Text = "Beautifly", Value = 267  },
                    new { Text = "Beedrill", Value = 15  },
                    new { Text = "Beheeyem", Value = 606  },
                    new { Text = "Beldum", Value = 374  },
                    new { Text = "Bellossom", Value = 182  },
                    new { Text = "Bellsprout", Value = 69  },
                    new { Text = "Bibarel", Value = 400  },
                    new { Text = "Bidoof", Value = 399  },
                    new { Text = "Bisharp", Value = 625  },
                    new { Text = "Blastoise", Value = 9  },
                    new { Text = "Blaziken", Value = 257  },
                    new { Text = "Blissey", Value = 242  },
                    new { Text = "Blitzle", Value = 522  },
                    new { Text = "Boldore", Value = 525  },
                    new { Text = "Bonsly", Value = 438  },
                    new { Text = "Bouffalant", Value = 626  },
                    new { Text = "Braviary", Value = 628  },
                    new { Text = "Breloom", Value = 286  },
                    new { Text = "Bronzong", Value = 437  },
                    new { Text = "Bronzor", Value = 436  },
                    new { Text = "Budew", Value = 406  },
                    new { Text = "Buizel", Value = 418  },
                    new { Text = "Bulbasaur", Value = 1  },
                    new { Text = "Buneary", Value = 427  },
                    new { Text = "Burmy", Value = 412  },
                    new { Text = "Butterfree", Value = 12  },
                    new { Text = "Cacnea", Value = 331  },
                    new { Text = "Cacturne", Value = 332  },
                    new { Text = "Camerupt", Value = 323  },
                    new { Text = "Carnivine", Value = 455  },
                    new { Text = "Carracosta", Value = 565  },
                    new { Text = "Carvanha", Value = 318  },
                    new { Text = "Cascoon", Value = 268  },
                    new { Text = "Castform", Value = 351  },
                    new { Text = "Caterpie", Value = 10  },
                    new { Text = "Celebi", Value = 251  },
                    new { Text = "Chandelure", Value = 609  },
                    new { Text = "Chansey", Value = 113  },
                    new { Text = "Charizard", Value = 6  },
                    new { Text = "Charmander", Value = 4  },
                    new { Text = "Charmeleon", Value = 5  },
                    new { Text = "Chatot", Value = 441  },
                    new { Text = "Cherrim", Value = 421  },
                    new { Text = "Cherubi", Value = 420  },
                    new { Text = "Chikorita", Value = 152  },
                    new { Text = "Chimchar", Value = 390  },
                    new { Text = "Chimecho", Value = 358  },
                    new { Text = "Chinchou", Value = 170  },
                    new { Text = "Chingling", Value = 433  },
                    new { Text = "Cinccino", Value = 573  },
                    new { Text = "Clamperl", Value = 366  },
                    new { Text = "Claydol", Value = 344  },
                    new { Text = "Clefable", Value = 36  },
                    new { Text = "Clefairy", Value = 35  },
                    new { Text = "Cleffa", Value = 173  },
                    new { Text = "Cloyster", Value = 91  },
                    new { Text = "Cobalion", Value = 638  },
                    new { Text = "Cofagrigus", Value = 563  },
                    new { Text = "Combee", Value = 415  },
                    new { Text = "Combusken", Value = 256  },
                    new { Text = "Conkeldurr", Value = 534  },
                    new { Text = "Corphish", Value = 341  },
                    new { Text = "Corsola", Value = 222  },
                    new { Text = "Cottonee", Value = 546  },
                    new { Text = "Cradily", Value = 346  },
                    new { Text = "Cranidos", Value = 408  },
                    new { Text = "Crawdaunt", Value = 342  },
                    new { Text = "Cresselia", Value = 488  },
                    new { Text = "Croagunk", Value = 453  },
                    new { Text = "Crobat", Value = 169  },
                    new { Text = "Croconaw", Value = 159  },
                    new { Text = "Crustle", Value = 558  },
                    new { Text = "Cryogonal", Value = 615  },
                    new { Text = "Cubchoo", Value = 613  },
                    new { Text = "Cubone", Value = 104  },
                    new { Text = "Cyndaquil", Value = 155  },
                    new { Text = "Darkrai", Value = 491  },
                    new { Text = "Darmanitan", Value = 555  },
                    new { Text = "Darumaka", Value = 554  },
                    new { Text = "Deerling", Value = 585  },
                    new { Text = "Deino", Value = 633  },
                    new { Text = "Delcatty", Value = 301  },
                    new { Text = "Delibird", Value = 225  },
                    new { Text = "Deoxys", Value = 386  },
                    new { Text = "Dewgong", Value = 87  },
                    new { Text = "Dewott", Value = 502  },
                    new { Text = "Dialga", Value = 483  },
                    new { Text = "Diglett", Value = 50  },
                    new { Text = "Ditto", Value = 132  },
                    new { Text = "Dodrio", Value = 85  },
                    new { Text = "Doduo", Value = 84  },
                    new { Text = "Donphan", Value = 232  },
                    new { Text = "Dragonair", Value = 148  },
                    new { Text = "Dragonite", Value = 149  },
                    new { Text = "Drapion", Value = 452  },
                    new { Text = "Dratini", Value = 147  },
                    new { Text = "Drifblim", Value = 426  },
                    new { Text = "Drifloon", Value = 425  },
                    new { Text = "Drilbur", Value = 529  },
                    new { Text = "Drowzee", Value = 96  },
                    new { Text = "Druddigon", Value = 621  },
                    new { Text = "Ducklett", Value = 580  },
                    new { Text = "Dugtrio", Value = 51  },
                    new { Text = "Dunsparce", Value = 206  },
                    new { Text = "Duosion", Value = 578  },
                    new { Text = "Durant", Value = 632  },
                    new { Text = "Dusclops", Value = 356  },
                    new { Text = "Dusknoir", Value = 477  },
                    new { Text = "Duskull", Value = 355  },
                    new { Text = "Dustox", Value = 269  },
                    new { Text = "Dwebble", Value = 557  },
                    new { Text = "Eelektrik", Value = 603  },
                    new { Text = "Eelektross", Value = 604  },
                    new { Text = "Eevee", Value = 133  },
                    new { Text = "Ekans", Value = 23  },
                    new { Text = "Electabuzz", Value = 125  },
                    new { Text = "Electivire", Value = 466  },
                    new { Text = "Electrike", Value = 309  },
                    new { Text = "Electrode", Value = 101  },
                    new { Text = "Elekid", Value = 239  },
                    new { Text = "Elgyem", Value = 605  },
                    new { Text = "Emboar", Value = 500  },
                    new { Text = "Emolga", Value = 587  },
                    new { Text = "Empoleon", Value = 395  },
                    new { Text = "Entei", Value = 244  },
                    new { Text = "Escavalier", Value = 589  },
                    new { Text = "Espeon", Value = 196  },
                    new { Text = "Excadrill", Value = 530  },
                    new { Text = "Exeggcute", Value = 102  },
                    new { Text = "Exeggutor", Value = 103  },
                    new { Text = "Exploud", Value = 295  },
                    new { Text = "Farfetch'd", Value = 83  },
                    new { Text = "Fearow", Value = 22  },
                    new { Text = "Feebas", Value = 349  },
                    new { Text = "Feraligatr", Value = 160  },
                    new { Text = "Ferroseed", Value = 597  },
                    new { Text = "Ferrothorn", Value = 598  },
                    new { Text = "Finneon", Value = 456  },
                    new { Text = "Flaaffy", Value = 180  },
                    new { Text = "Flareon", Value = 136  },
                    new { Text = "Floatzel", Value = 419  },
                    new { Text = "Flygon", Value = 330  },
                    new { Text = "Foongus", Value = 590  },
                    new { Text = "Forretress", Value = 205  },
                    new { Text = "Fraxure", Value = 611  },
                    new { Text = "Frillish", Value = 592  },
                    new { Text = "Froslass", Value = 478  },
                    new { Text = "Furret", Value = 162  },
                    new { Text = "Gabite", Value = 444  },
                    new { Text = "Gallade", Value = 475  },
                    new { Text = "Galvantula", Value = 596  },
                    new { Text = "Garbodor", Value = 569  },
                    new { Text = "Garchomp", Value = 445  },
                    new { Text = "Gardevoir", Value = 282  },
                    new { Text = "Gastly", Value = 92  },
                    new { Text = "Gastrodon", Value = 423  },
                    new { Text = "Genesect", Value = 649  },
                    new { Text = "Gengar", Value = 94  },
                    new { Text = "Geodude", Value = 74  },
                    new { Text = "Gible", Value = 443  },
                    new { Text = "Gigalith", Value = 526  },
                    new { Text = "Girafarig", Value = 203  },
                    new { Text = "Giratina", Value = 487  },
                    new { Text = "Glaceon", Value = 471  },
                    new { Text = "Glalie", Value = 362  },
                    new { Text = "Glameow", Value = 431  },
                    new { Text = "Gligar", Value = 207  },
                    new { Text = "Gliscor", Value = 472  },
                    new { Text = "Gloom", Value = 44  },
                    new { Text = "Golbat", Value = 42  },
                    new { Text = "Goldeen", Value = 118  },
                    new { Text = "Golduck", Value = 55  },
                    new { Text = "Golem", Value = 76  },
                    new { Text = "Golett", Value = 622  },
                    new { Text = "Golurk", Value = 623  },
                    new { Text = "Gorebyss", Value = 368  },
                    new { Text = "Gothita", Value = 574  },
                    new { Text = "Gothitelle", Value = 576  },
                    new { Text = "Gothorita", Value = 575  },
                    new { Text = "Granbull", Value = 210  },
                    new { Text = "Graveler", Value = 75  },
                    new { Text = "Grimer", Value = 88  },
                    new { Text = "Grotle", Value = 388  },
                    new { Text = "Groudon", Value = 383  },
                    new { Text = "Grovyle", Value = 253  },
                    new { Text = "Growlithe", Value = 58  },
                    new { Text = "Grumpig", Value = 326  },
                    new { Text = "Gulpin", Value = 316  },
                    new { Text = "Gurdurr", Value = 533  },
                    new { Text = "Gyarados", Value = 130  },
                    new { Text = "Happiny", Value = 440  },
                    new { Text = "Hariyama", Value = 297  },
                    new { Text = "Haunter", Value = 93  },
                    new { Text = "Haxorus", Value = 612  },
                    new { Text = "Heatmor", Value = 631  },
                    new { Text = "Heatran", Value = 485  },
                    new { Text = "Heracross", Value = 214  },
                    new { Text = "Herdier", Value = 507  },
                    new { Text = "Hippopotas", Value = 449  },
                    new { Text = "Hippowdon", Value = 450  },
                    new { Text = "Hitmonchan", Value = 107  },
                    new { Text = "Hitmonlee", Value = 106  },
                    new { Text = "Hitmontop", Value = 237  },
                    new { Text = "Honchkrow", Value = 430  },
                    new { Text = "Ho-Oh", Value = 250  },
                    new { Text = "Hoothoot", Value = 163  },
                    new { Text = "Hoppip", Value = 187  },
                    new { Text = "Horsea", Value = 116  },
                    new { Text = "Houndoom", Value = 229  },
                    new { Text = "Houndour", Value = 228  },
                    new { Text = "Huntail", Value = 367  },
                    new { Text = "Hydreigon", Value = 635  },
                    new { Text = "Hypno", Value = 97  },
                    new { Text = "Igglybuff", Value = 174  },
                    new { Text = "Illumise", Value = 314  },
                    new { Text = "Infernape", Value = 392  },
                    new { Text = "Ivysaur", Value = 2  },
                    new { Text = "Jellicent", Value = 593  },
                    new { Text = "Jigglypuff", Value = 39  },
                    new { Text = "Jirachi", Value = 385  },
                    new { Text = "Jolteon", Value = 135  },
                    new { Text = "Joltik", Value = 595  },
                    new { Text = "Jumpluff", Value = 189  },
                    new { Text = "Jynx", Value = 124  },
                    new { Text = "Kabuto", Value = 140  },
                    new { Text = "Kabutops", Value = 141  },
                    new { Text = "Kadabra", Value = 64  },
                    new { Text = "Kakuna", Value = 14  },
                    new { Text = "Kangaskhan", Value = 115  },
                    new { Text = "Karrablast", Value = 588  },
                    new { Text = "Kecleon", Value = 352  },
                    new { Text = "Keldeo", Value = 647  },
                    new { Text = "Kingdra", Value = 230  },
                    new { Text = "Kingler", Value = 99  },
                    new { Text = "Kirlia", Value = 281  },
                    new { Text = "Klang", Value = 600  },
                    new { Text = "Klink", Value = 599  },
                    new { Text = "Klinklang", Value = 601  },
                    new { Text = "Koffing", Value = 109  },
                    new { Text = "Krabby", Value = 98  },
                    new { Text = "Kricketot", Value = 401  },
                    new { Text = "Kricketune", Value = 402  },
                    new { Text = "Krokorok", Value = 552  },
                    new { Text = "Krookodile", Value = 553  },
                    new { Text = "Kyogre", Value = 382  },
                    new { Text = "Kyurem", Value = 646  },
                    new { Text = "Lairon", Value = 305  },
                    new { Text = "Lampent", Value = 608  },
                    new { Text = "Landorus", Value = 645  },
                    new { Text = "Lanturn", Value = 171  },
                    new { Text = "Lapras", Value = 131  },
                    new { Text = "Larvesta", Value = 636  },
                    new { Text = "Larvitar", Value = 246  },
                    new { Text = "Latias", Value = 380  },
                    new { Text = "Latios", Value = 381  },
                    new { Text = "Leafeon", Value = 470  },
                    new { Text = "Leavanny", Value = 542  },
                    new { Text = "Ledian", Value = 166  },
                    new { Text = "Ledyba", Value = 165  },
                    new { Text = "Lickilicky", Value = 463  },
                    new { Text = "Lickitung", Value = 108  },
                    new { Text = "Liepard", Value = 510  },
                    new { Text = "Lileep", Value = 345  },
                    new { Text = "Lilligant", Value = 549  },
                    new { Text = "Lillipup", Value = 506  },
                    new { Text = "Linoone", Value = 264  },
                    new { Text = "Litwick", Value = 607  },
                    new { Text = "Lombre", Value = 271  },
                    new { Text = "Lopunny", Value = 428  },
                    new { Text = "Lotad", Value = 270  },
                    new { Text = "Loudred", Value = 294  },
                    new { Text = "Lucario", Value = 448  },
                    new { Text = "Ludicolo", Value = 272  },
                    new { Text = "Lugia", Value = 249  },
                    new { Text = "Lumineon", Value = 457  },
                    new { Text = "Lunatone", Value = 337  },
                    new { Text = "Luvdisc", Value = 370  },
                    new { Text = "Luxio", Value = 404  },
                    new { Text = "Luxray", Value = 405  },
                    new { Text = "Machamp", Value = 68  },
                    new { Text = "Machoke", Value = 67  },
                    new { Text = "Machop", Value = 66  },
                    new { Text = "Magby", Value = 240  },
                    new { Text = "Magcargo", Value = 219  },
                    new { Text = "Magikarp", Value = 129  },
                    new { Text = "Magmar", Value = 126  },
                    new { Text = "Magmortar", Value = 467  },
                    new { Text = "Magnemite", Value = 81  },
                    new { Text = "Magneton", Value = 82  },
                    new { Text = "Magnezone", Value = 462  },
                    new { Text = "Makuhita", Value = 296  },
                    new { Text = "Mamoswine", Value = 473  },
                    new { Text = "Manaphy", Value = 490  },
                    new { Text = "Mandibuzz", Value = 630  },
                    new { Text = "Manectric", Value = 310  },
                    new { Text = "Mankey", Value = 56  },
                    new { Text = "Mantine", Value = 226  },
                    new { Text = "Mantyke", Value = 458  },
                    new { Text = "Maractus", Value = 556  },
                    new { Text = "Mareep", Value = 179  },
                    new { Text = "Marill", Value = 183  },
                    new { Text = "Marowak", Value = 105  },
                    new { Text = "Marshtomp", Value = 259  },
                    new { Text = "Masquerain", Value = 284  },
                    new { Text = "Mawile", Value = 303  },
                    new { Text = "Medicham", Value = 308  },
                    new { Text = "Meditite", Value = 307  },
                    new { Text = "Meganium", Value = 154  },
                    new { Text = "Meloetta", Value = 648  },
                    new { Text = "Meowth", Value = 52  },
                    new { Text = "Mesprit", Value = 481  },
                    new { Text = "Metagross", Value = 376  },
                    new { Text = "Metang", Value = 375  },
                    new { Text = "Metapod", Value = 11  },
                    new { Text = "Mew", Value = 151  },
                    new { Text = "Mewtwo", Value = 150  },
                    new { Text = "Mienfoo", Value = 619  },
                    new { Text = "Mienshao", Value = 620  },
                    new { Text = "Mightyena", Value = 262  },
                    new { Text = "Milotic", Value = 350  },
                    new { Text = "Miltank", Value = 241  },
                    new { Text = "Mime Jr.", Value = 439  },
                    new { Text = "Minccino", Value = 572  },
                    new { Text = "Minun", Value = 312  },
                    new { Text = "Misdreavus", Value = 200  },
                    new { Text = "Mismagius", Value = 429  },
                    new { Text = "Moltres", Value = 146  },
                    new { Text = "Monferno", Value = 391  },
                    new { Text = "Mothim", Value = 414  },
                    new { Text = "Mr. Mime", Value = 122  },
                    new { Text = "Mudkip", Value = 258  },
                    new { Text = "Muk", Value = 89  },
                    new { Text = "Munchlax", Value = 446  },
                    new { Text = "Munna", Value = 517  },
                    new { Text = "Murkrow", Value = 198  },
                    new { Text = "Musharna", Value = 518  },
                    new { Text = "Natu", Value = 177  },
                    new { Text = "Nidoking", Value = 34  },
                    new { Text = "Nidoqueen", Value = 31  },
                    new { Text = "Nidoran♀", Value = 29  },
                    new { Text = "Nidoran♂", Value = 32  },
                    new { Text = "Nidorina", Value = 30  },
                    new { Text = "Nidorino", Value = 33  },
                    new { Text = "Nincada", Value = 290  },
                    new { Text = "Ninetales", Value = 38  },
                    new { Text = "Ninjask", Value = 291  },
                    new { Text = "Noctowl", Value = 164  },
                    new { Text = "Nosepass", Value = 299  },
                    new { Text = "Numel", Value = 322  },
                    new { Text = "Nuzleaf", Value = 274  },
                    new { Text = "Octillery", Value = 224  },
                    new { Text = "Oddish", Value = 43  },
                    new { Text = "Omanyte", Value = 138  },
                    new { Text = "Omastar", Value = 139  },
                    new { Text = "Onix", Value = 95  },
                    new { Text = "Oshawott", Value = 501  },
                    new { Text = "Pachirisu", Value = 417  },
                    new { Text = "Palkia", Value = 484  },
                    new { Text = "Palpitoad", Value = 536  },
                    new { Text = "Panpour", Value = 515  },
                    new { Text = "Pansage", Value = 511  },
                    new { Text = "Pansear", Value = 513  },
                    new { Text = "Paras", Value = 46  },
                    new { Text = "Parasect", Value = 47  },
                    new { Text = "Patrat", Value = 504  },
                    new { Text = "Pawniard", Value = 624  },
                    new { Text = "Pelipper", Value = 279  },
                    new { Text = "Persian", Value = 53  },
                    new { Text = "Petilil", Value = 548  },
                    new { Text = "Phanpy", Value = 231  },
                    new { Text = "Phione", Value = 489  },
                    new { Text = "Pichu", Value = 172  },
                    new { Text = "Pidgeot", Value = 18  },
                    new { Text = "Pidgeotto", Value = 17  },
                    new { Text = "Pidgey", Value = 16  },
                    new { Text = "Pidove", Value = 519  },
                    new { Text = "Pignite", Value = 499  },
                    new { Text = "Pikachu", Value = 25  },
                    new { Text = "Piloswine", Value = 221  },
                    new { Text = "Pineco", Value = 204  },
                    new { Text = "Pinsir", Value = 127  },
                    new { Text = "Piplup", Value = 393  },
                    new { Text = "Plusle", Value = 311  },
                    new { Text = "Politoed", Value = 186  },
                    new { Text = "Poliwag", Value = 60  },
                    new { Text = "Poliwhirl", Value = 61  },
                    new { Text = "Poliwrath", Value = 62  },
                    new { Text = "Ponyta", Value = 77  },
                    new { Text = "Poochyena", Value = 261  },
                    new { Text = "Porygon", Value = 137  },
                    new { Text = "Porygon2", Value = 233  },
                    new { Text = "Porygon-Z", Value = 474  },
                    new { Text = "Primeape", Value = 57  },
                    new { Text = "Prinplup", Value = 394  },
                    new { Text = "Probopass", Value = 476  },
                    new { Text = "Psyduck", Value = 54  },
                    new { Text = "Pupitar", Value = 247  },
                    new { Text = "Purrloin", Value = 509  },
                    new { Text = "Purugly", Value = 432  },
                    new { Text = "Quagsire", Value = 195  },
                    new { Text = "Quilava", Value = 156  },
                    new { Text = "Qwilfish", Value = 211  },
                    new { Text = "Raichu", Value = 26  },
                    new { Text = "Raikou", Value = 243  },
                    new { Text = "Ralts", Value = 280  },
                    new { Text = "Rampardos", Value = 409  },
                    new { Text = "Rapidash", Value = 78  },
                    new { Text = "Raticate", Value = 20  },
                    new { Text = "Rattata", Value = 19  },
                    new { Text = "Rayquaza", Value = 384  },
                    new { Text = "Regice", Value = 378  },
                    new { Text = "Regigigas", Value = 486  },
                    new { Text = "Regirock", Value = 377  },
                    new { Text = "Registeel", Value = 379  },
                    new { Text = "Relicanth", Value = 369  },
                    new { Text = "Remoraid", Value = 223  },
                    new { Text = "Reshiram", Value = 643  },
                    new { Text = "Reuniclus", Value = 579  },
                    new { Text = "Rhydon", Value = 112  },
                    new { Text = "Rhyhorn", Value = 111  },
                    new { Text = "Rhyperior", Value = 464  },
                    new { Text = "Riolu", Value = 447  },
                    new { Text = "Roggenrola", Value = 524  },
                    new { Text = "Roselia", Value = 315  },
                    new { Text = "Roserade", Value = 407  },
                    new { Text = "Rotom", Value = 479  },
                    new { Text = "Rufflet", Value = 627  },
                    new { Text = "Sableye", Value = 302  },
                    new { Text = "Salamence", Value = 373  },
                    new { Text = "Samurott", Value = 503  },
                    new { Text = "Sandile", Value = 551  },
                    new { Text = "Sandshrew", Value = 27  },
                    new { Text = "Sandslash", Value = 28  },
                    new { Text = "Sawk", Value = 539  },
                    new { Text = "Sawsbuck", Value = 586  },
                    new { Text = "Sceptile", Value = 254  },
                    new { Text = "Scizor", Value = 212  },
                    new { Text = "Scolipede", Value = 545  },
                    new { Text = "Scrafty", Value = 560  },
                    new { Text = "Scraggy", Value = 559  },
                    new { Text = "Scyther", Value = 123  },
                    new { Text = "Seadra", Value = 117  },
                    new { Text = "Seaking", Value = 119  },
                    new { Text = "Sealeo", Value = 364  },
                    new { Text = "Seedot", Value = 273  },
                    new { Text = "Seel", Value = 86  },
                    new { Text = "Seismitoad", Value = 537  },
                    new { Text = "Sentret", Value = 161  },
                    new { Text = "Serperior", Value = 497  },
                    new { Text = "Servine", Value = 496  },
                    new { Text = "Seviper", Value = 336  },
                    new { Text = "Sewaddle", Value = 540  },
                    new { Text = "Sharpedo", Value = 319  },
                    new { Text = "Shaymin", Value = 492  },
                    new { Text = "Shedinja", Value = 292  },
                    new { Text = "Shelgon", Value = 372  },
                    new { Text = "Shellder", Value = 90  },
                    new { Text = "Shellos", Value = 422  },
                    new { Text = "Shelmet", Value = 616  },
                    new { Text = "Shieldon", Value = 410  },
                    new { Text = "Shiftry", Value = 275  },
                    new { Text = "Shinx", Value = 403  },
                    new { Text = "Shroomish", Value = 285  },
                    new { Text = "Shuckle", Value = 213  },
                    new { Text = "Shuppet", Value = 353  },
                    new { Text = "Sigilyph", Value = 561  },
                    new { Text = "Silcoon", Value = 266  },
                    new { Text = "Simipour", Value = 516  },
                    new { Text = "Simisage", Value = 512  },
                    new { Text = "Simisear", Value = 514  },
                    new { Text = "Skarmory", Value = 227  },
                    new { Text = "Skiploom", Value = 188  },
                    new { Text = "Skitty", Value = 300  },
                    new { Text = "Skorupi", Value = 451  },
                    new { Text = "Skuntank", Value = 435  },
                    new { Text = "Slaking", Value = 289  },
                    new { Text = "Slakoth", Value = 287  },
                    new { Text = "Slowbro", Value = 80  },
                    new { Text = "Slowking", Value = 199  },
                    new { Text = "Slowpoke", Value = 79  },
                    new { Text = "Slugma", Value = 218  },
                    new { Text = "Smeargle", Value = 235  },
                    new { Text = "Smoochum", Value = 238  },
                    new { Text = "Sneasel", Value = 215  },
                    new { Text = "Snivy", Value = 495  },
                    new { Text = "Snorlax", Value = 143  },
                    new { Text = "Snorunt", Value = 361  },
                    new { Text = "Snover", Value = 459  },
                    new { Text = "Snubbull", Value = 209  },
                    new { Text = "Solosis", Value = 577  },
                    new { Text = "Solrock", Value = 338  },
                    new { Text = "Spearow", Value = 21  },
                    new { Text = "Spheal", Value = 363  },
                    new { Text = "Spinarak", Value = 167  },
                    new { Text = "Spinda", Value = 327  },
                    new { Text = "Spiritomb", Value = 442  },
                    new { Text = "Spoink", Value = 325  },
                    new { Text = "Squirtle", Value = 7  },
                    new { Text = "Stantler", Value = 234  },
                    new { Text = "Staraptor", Value = 398  },
                    new { Text = "Staravia", Value = 397  },
                    new { Text = "Starly", Value = 396  },
                    new { Text = "Starmie", Value = 121  },
                    new { Text = "Staryu", Value = 120  },
                    new { Text = "Steelix", Value = 208  },
                    new { Text = "Stoutland", Value = 508  },
                    new { Text = "Stunfisk", Value = 618  },
                    new { Text = "Stunky", Value = 434  },
                    new { Text = "Sudowoodo", Value = 185  },
                    new { Text = "Suicune", Value = 245  },
                    new { Text = "Sunflora", Value = 192  },
                    new { Text = "Sunkern", Value = 191  },
                    new { Text = "Surskit", Value = 283  },
                    new { Text = "Swablu", Value = 333  },
                    new { Text = "Swadloon", Value = 541  },
                    new { Text = "Swalot", Value = 317  },
                    new { Text = "Swampert", Value = 260  },
                    new { Text = "Swanna", Value = 581  },
                    new { Text = "Swellow", Value = 277  },
                    new { Text = "Swinub", Value = 220  },
                    new { Text = "Swoobat", Value = 528  },
                    new { Text = "Taillow", Value = 276  },
                    new { Text = "Tangela", Value = 114  },
                    new { Text = "Tangrowth", Value = 465  },
                    new { Text = "Tauros", Value = 128  },
                    new { Text = "Teddiursa", Value = 216  },
                    new { Text = "Tentacool", Value = 72  },
                    new { Text = "Tentacruel", Value = 73  },
                    new { Text = "Tepig", Value = 498  },
                    new { Text = "Terrakion", Value = 639  },
                    new { Text = "Throh", Value = 538  },
                    new { Text = "Thundurus", Value = 642  },
                    new { Text = "Timburr", Value = 532  },
                    new { Text = "Tirtouga", Value = 564  },
                    new { Text = "Togekiss", Value = 468  },
                    new { Text = "Togepi", Value = 175  },
                    new { Text = "Togetic", Value = 176  },
                    new { Text = "Torchic", Value = 255  },
                    new { Text = "Torkoal", Value = 324  },
                    new { Text = "Tornadus", Value = 641  },
                    new { Text = "Torterra", Value = 389  },
                    new { Text = "Totodile", Value = 158  },
                    new { Text = "Toxicroak", Value = 454  },
                    new { Text = "Tranquill", Value = 520  },
                    new { Text = "Trapinch", Value = 328  },
                    new { Text = "Treecko", Value = 252  },
                    new { Text = "Tropius", Value = 357  },
                    new { Text = "Trubbish", Value = 568  },
                    new { Text = "Turtwig", Value = 387  },
                    new { Text = "Tympole", Value = 535  },
                    new { Text = "Tynamo", Value = 602  },
                    new { Text = "Typhlosion", Value = 157  },
                    new { Text = "Tyranitar", Value = 248  },
                    new { Text = "Tyrogue", Value = 236  },
                    new { Text = "Umbreon", Value = 197  },
                    new { Text = "Unfezant", Value = 521  },
                    new { Text = "Unown", Value = 201  },
                    new { Text = "Ursaring", Value = 217  },
                    new { Text = "Uxie", Value = 480  },
                    new { Text = "Vanillish", Value = 583  },
                    new { Text = "Vanillite", Value = 582  },
                    new { Text = "Vanilluxe", Value = 584  },
                    new { Text = "Vaporeon", Value = 134  },
                    new { Text = "Venipede", Value = 543  },
                    new { Text = "Venomoth", Value = 49  },
                    new { Text = "Venonat", Value = 48  },
                    new { Text = "Venusaur", Value = 3  },
                    new { Text = "Vespiquen", Value = 416  },
                    new { Text = "Vibrava", Value = 329  },
                    new { Text = "Victini", Value = 494  },
                    new { Text = "Victreebel", Value = 71  },
                    new { Text = "Vigoroth", Value = 288  },
                    new { Text = "Vileplume", Value = 45  },
                    new { Text = "Virizion", Value = 640  },
                    new { Text = "Volbeat", Value = 313  },
                    new { Text = "Volcarona", Value = 637  },
                    new { Text = "Voltorb", Value = 100  },
                    new { Text = "Vullaby", Value = 629  },
                    new { Text = "Vulpix", Value = 37  },
                    new { Text = "Wailmer", Value = 320  },
                    new { Text = "Wailord", Value = 321  },
                    new { Text = "Walrein", Value = 365  },
                    new { Text = "Wartortle", Value = 8  },
                    new { Text = "Watchog", Value = 505  },
                    new { Text = "Weavile", Value = 461  },
                    new { Text = "Weedle", Value = 13  },
                    new { Text = "Weepinbell", Value = 70  },
                    new { Text = "Weezing", Value = 110  },
                    new { Text = "Whimsicott", Value = 547  },
                    new { Text = "Whirlipede", Value = 544  },
                    new { Text = "Whiscash", Value = 340  },
                    new { Text = "Whismur", Value = 293  },
                    new { Text = "Wigglytuff", Value = 40  },
                    new { Text = "Wingull", Value = 278  },
                    new { Text = "Wobbuffet", Value = 202  },
                    new { Text = "Woobat", Value = 527  },
                    new { Text = "Wooper", Value = 194  },
                    new { Text = "Wormadam", Value = 413  },
                    new { Text = "Wurmple", Value = 265  },
                    new { Text = "Wynaut", Value = 360  },
                    new { Text = "Xatu", Value = 178  },
                    new { Text = "Yamask", Value = 562  },
                    new { Text = "Yanma", Value = 193  },
                    new { Text = "Yanmega", Value = 469  },
                    new { Text = "Zangoose", Value = 335  },
                    new { Text = "Zapdos", Value = 145  },
                    new { Text = "Zebstrika", Value = 523  },
                    new { Text = "Zekrom", Value = 644  },
                    new { Text = "Zigzagoon", Value = 263  },
                    new { Text = "Zoroark", Value = 571  },
                    new { Text = "Zorua", Value = 570  },
                    new { Text = "Zubat", Value = 41  },
                    new { Text = "Zweilous", Value = 634  },
            };
            var move_list = new[] {
                    new { Text = "", Value = 0  },
                    new { Text = "Absorb", Value = 71  },
                    new { Text = "Acid", Value = 51  },
                    new { Text = "Acid Armor", Value = 151  },
                    new { Text = "Acid Spray", Value = 491  },
                    new { Text = "Acrobatics", Value = 512  },
                    new { Text = "Acupressure", Value = 367  },
                    new { Text = "Aerial Ace", Value = 332  },
                    new { Text = "Aeroblast", Value = 177  },
                    new { Text = "After You", Value = 495  },
                    new { Text = "Agility", Value = 97  },
                    new { Text = "Air Cutter", Value = 314  },
                    new { Text = "Air Slash", Value = 403  },
                    new { Text = "Ally Switch", Value = 502  },
                    new { Text = "Amnesia", Value = 133  },
                    new { Text = "Ancient Power", Value = 246  },
                    new { Text = "Aqua Jet", Value = 453  },
                    new { Text = "Aqua Ring", Value = 392  },
                    new { Text = "Aqua Tail", Value = 401  },
                    new { Text = "Arm Thrust", Value = 292  },
                    new { Text = "Aromatherapy", Value = 312  },
                    new { Text = "Assist", Value = 274  },
                    new { Text = "Assurance", Value = 372  },
                    new { Text = "Astonish", Value = 310  },
                    new { Text = "Attack Order", Value = 454  },
                    new { Text = "Attract", Value = 213  },
                    new { Text = "Aura Sphere", Value = 396  },
                    new { Text = "Aurora Beam", Value = 62  },
                    new { Text = "Autotomize", Value = 475  },
                    new { Text = "Avalanche", Value = 419  },
                    new { Text = "Barrage", Value = 140  },
                    new { Text = "Barrier", Value = 112  },
                    new { Text = "Baton Pass", Value = 226  },
                    new { Text = "Beat Up", Value = 251  },
                    new { Text = "Belly Drum", Value = 187  },
                    new { Text = "Bestow", Value = 516  },
                    new { Text = "Bide", Value = 117  },
                    new { Text = "Bind", Value = 20  },
                    new { Text = "Bite", Value = 44  },
                    new { Text = "Blast Burn", Value = 307  },
                    new { Text = "Blaze Kick", Value = 299  },
                    new { Text = "Blizzard", Value = 59  },
                    new { Text = "Block", Value = 335  },
                    new { Text = "Blue Flare", Value = 551  },
                    new { Text = "Body Slam", Value = 34  },
                    new { Text = "Bolt Strike", Value = 550  },
                    new { Text = "Bone Club", Value = 125  },
                    new { Text = "Bone Rush", Value = 198  },
                    new { Text = "Bonemerang", Value = 155  },
                    new { Text = "Bounce", Value = 340  },
                    new { Text = "Brave Bird", Value = 413  },
                    new { Text = "Brick Break", Value = 280  },
                    new { Text = "Brine", Value = 362  },
                    new { Text = "Bubble", Value = 145  },
                    new { Text = "Bubble Beam", Value = 61  },
                    new { Text = "Bug Bite", Value = 450  },
                    new { Text = "Bug Buzz", Value = 405  },
                    new { Text = "Bulk Up", Value = 339  },
                    new { Text = "Bulldoze", Value = 523  },
                    new { Text = "Bullet Punch", Value = 418  },
                    new { Text = "Bullet Seed", Value = 331  },
                    new { Text = "Calm Mind", Value = 347  },
                    new { Text = "Camouflage", Value = 293  },
                    new { Text = "Captivate", Value = 445  },
                    new { Text = "Charge", Value = 268  },
                    new { Text = "Charge Beam", Value = 451  },
                    new { Text = "Charm", Value = 204  },
                    new { Text = "Chatter", Value = 448  },
                    new { Text = "Chip Away", Value = 498  },
                    new { Text = "Circle Throw", Value = 509  },
                    new { Text = "Clamp", Value = 128  },
                    new { Text = "Clear Smog", Value = 499  },
                    new { Text = "Close Combat", Value = 370  },
                    new { Text = "Coil", Value = 489  },
                    new { Text = "Comet Punch", Value = 4  },
                    new { Text = "Confuse Ray", Value = 109  },
                    new { Text = "Confusion", Value = 93  },
                    new { Text = "Constrict", Value = 132  },
                    new { Text = "Conversion", Value = 160  },
                    new { Text = "Conversion 2", Value = 176  },
                    new { Text = "Copycat", Value = 383  },
                    new { Text = "Cosmic Power", Value = 322  },
                    new { Text = "Cotton Guard", Value = 538  },
                    new { Text = "Cotton Spore", Value = 178  },
                    new { Text = "Counter", Value = 68  },
                    new { Text = "Covet", Value = 343  },
                    new { Text = "Crabhammer", Value = 152  },
                    new { Text = "Cross Chop", Value = 238  },
                    new { Text = "Cross Poison", Value = 440  },
                    new { Text = "Crunch", Value = 242  },
                    new { Text = "Crush Claw", Value = 306  },
                    new { Text = "Crush Grip", Value = 462  },
                    new { Text = "Curse", Value = 174  },
                    new { Text = "Cut", Value = 15  },
                    new { Text = "Dark Pulse", Value = 399  },
                    new { Text = "Dark Void", Value = 464  },
                    new { Text = "Defend Order", Value = 455  },
                    new { Text = "Defense Curl", Value = 111  },
                    new { Text = "Defog", Value = 432  },
                    new { Text = "Destiny Bond", Value = 194  },
                    new { Text = "Detect", Value = 197  },
                    new { Text = "Dig", Value = 91  },
                    new { Text = "Disable", Value = 50  },
                    new { Text = "Discharge", Value = 435  },
                    new { Text = "Dive", Value = 291  },
                    new { Text = "Dizzy Punch", Value = 146  },
                    new { Text = "Doom Desire", Value = 353  },
                    new { Text = "Double Hit", Value = 458  },
                    new { Text = "Double Kick", Value = 24  },
                    new { Text = "Double Slap", Value = 3  },
                    new { Text = "Double Team", Value = 104  },
                    new { Text = "Double-Edge", Value = 38  },
                    new { Text = "Draco Meteor", Value = 434  },
                    new { Text = "Dragon Breath", Value = 225  },
                    new { Text = "Dragon Claw", Value = 337  },
                    new { Text = "Dragon Dance", Value = 349  },
                    new { Text = "Dragon Pulse", Value = 406  },
                    new { Text = "Dragon Rage", Value = 82  },
                    new { Text = "Dragon Rush", Value = 407  },
                    new { Text = "Dragon Tail", Value = 525  },
                    new { Text = "Drain Punch", Value = 409  },
                    new { Text = "Dream Eater", Value = 138  },
                    new { Text = "Drill Peck", Value = 65  },
                    new { Text = "Drill Run", Value = 529  },
                    new { Text = "Dual Chop", Value = 530  },
                    new { Text = "Dynamic Punch", Value = 223  },
                    new { Text = "Earth Power", Value = 414  },
                    new { Text = "Earthquake", Value = 89  },
                    new { Text = "Echoed Voice", Value = 497  },
                    new { Text = "Egg Bomb", Value = 121  },
                    new { Text = "Electro Ball", Value = 486  },
                    new { Text = "Electroweb", Value = 527  },
                    new { Text = "Embargo", Value = 373  },
                    new { Text = "Ember", Value = 52  },
                    new { Text = "Encore", Value = 227  },
                    new { Text = "Endeavor", Value = 283  },
                    new { Text = "Endure", Value = 203  },
                    new { Text = "Energy Ball", Value = 412  },
                    new { Text = "Entrainment", Value = 494  },
                    new { Text = "Eruption", Value = 284  },
                    new { Text = "Explosion", Value = 153  },
                    new { Text = "Extrasensory", Value = 326  },
                    new { Text = "Extreme Speed", Value = 245  },
                    new { Text = "Facade", Value = 263  },
                    new { Text = "Fake Out", Value = 252  },
                    new { Text = "Fake Tears", Value = 313  },
                    new { Text = "False Swipe", Value = 206  },
                    new { Text = "Feather Dance", Value = 297  },
                    new { Text = "Feint", Value = 364  },
                    new { Text = "Feint Attack", Value = 185  },
                    new { Text = "Fiery Dance", Value = 552  },
                    new { Text = "Final Gambit", Value = 515  },
                    new { Text = "Fire Blast", Value = 126  },
                    new { Text = "Fire Fang", Value = 424  },
                    new { Text = "Fire Pledge", Value = 519  },
                    new { Text = "Fire Punch", Value = 7  },
                    new { Text = "Fire Spin", Value = 83  },
                    new { Text = "Fissure", Value = 90  },
                    new { Text = "Flail", Value = 175  },
                    new { Text = "Flame Burst", Value = 481  },
                    new { Text = "Flame Charge", Value = 488  },
                    new { Text = "Flame Wheel", Value = 172  },
                    new { Text = "Flamethrower", Value = 53  },
                    new { Text = "Flare Blitz", Value = 394  },
                    new { Text = "Flash", Value = 148  },
                    new { Text = "Flash Cannon", Value = 430  },
                    new { Text = "Flatter", Value = 260  },
                    new { Text = "Fling", Value = 374  },
                    new { Text = "Fly", Value = 19  },
                    new { Text = "Focus Blast", Value = 411  },
                    new { Text = "Focus Energy", Value = 116  },
                    new { Text = "Focus Punch", Value = 264  },
                    new { Text = "Follow Me", Value = 266  },
                    new { Text = "Force Palm", Value = 395  },
                    new { Text = "Foresight", Value = 193  },
                    new { Text = "Foul Play", Value = 492  },
                    new { Text = "Freeze Shock", Value = 553  },
                    new { Text = "Frenzy Plant", Value = 338  },
                    new { Text = "Frost Breath", Value = 524  },
                    new { Text = "Frustration", Value = 218  },
                    new { Text = "Fury Attack", Value = 31  },
                    new { Text = "Fury Cutter", Value = 210  },
                    new { Text = "Fury Swipes", Value = 154  },
                    new { Text = "Fusion Bolt", Value = 559  },
                    new { Text = "Fusion Flare", Value = 558  },
                    new { Text = "Future Sight", Value = 248  },
                    new { Text = "Gastro Acid", Value = 380  },
                    new { Text = "Gear Grind", Value = 544  },
                    new { Text = "Giga Drain", Value = 202  },
                    new { Text = "Giga Impact", Value = 416  },
                    new { Text = "Glaciate", Value = 549  },
                    new { Text = "Glare", Value = 137  },
                    new { Text = "Grass Knot", Value = 447  },
                    new { Text = "Grass Pledge", Value = 520  },
                    new { Text = "Grass Whistle", Value = 320  },
                    new { Text = "Gravity", Value = 356  },
                    new { Text = "Growl", Value = 45  },
                    new { Text = "Growth", Value = 74  },
                    new { Text = "Grudge", Value = 288  },
                    new { Text = "Guard Split", Value = 470  },
                    new { Text = "Guard Swap", Value = 385  },
                    new { Text = "Guillotine", Value = 12  },
                    new { Text = "Gunk Shot", Value = 441  },
                    new { Text = "Gust", Value = 16  },
                    new { Text = "Gyro Ball", Value = 360  },
                    new { Text = "Hail", Value = 258  },
                    new { Text = "Hammer Arm", Value = 359  },
                    new { Text = "Harden", Value = 106  },
                    new { Text = "Haze", Value = 114  },
                    new { Text = "Head Charge", Value = 543  },
                    new { Text = "Head Smash", Value = 457  },
                    new { Text = "Headbutt", Value = 29  },
                    new { Text = "Heal Bell", Value = 215  },
                    new { Text = "Heal Block", Value = 377  },
                    new { Text = "Heal Order", Value = 456  },
                    new { Text = "Heal Pulse", Value = 505  },
                    new { Text = "Healing Wish", Value = 361  },
                    new { Text = "Heart Stamp", Value = 531  },
                    new { Text = "Heart Swap", Value = 391  },
                    new { Text = "Heat Crash", Value = 535  },
                    new { Text = "Heat Wave", Value = 257  },
                    new { Text = "Heavy Slam", Value = 484  },
                    new { Text = "Helping Hand", Value = 270  },
                    new { Text = "Hex", Value = 506  },
                    new { Text = "Hidden Power", Value = 237  },
                    new { Text = "High Jump Kick", Value = 136  },
                    new { Text = "Hone Claws", Value = 468  },
                    new { Text = "Horn Attack", Value = 30  },
                    new { Text = "Horn Drill", Value = 32  },
                    new { Text = "Horn Leech", Value = 532  },
                    new { Text = "Howl", Value = 336  },
                    new { Text = "Hurricane", Value = 542  },
                    new { Text = "Hydro Cannon", Value = 308  },
                    new { Text = "Hydro Pump", Value = 56  },
                    new { Text = "Hyper Beam", Value = 63  },
                    new { Text = "Hyper Fang", Value = 158  },
                    new { Text = "Hyper Voice", Value = 304  },
                    new { Text = "Hypnosis", Value = 95  },
                    new { Text = "Ice Ball", Value = 301  },
                    new { Text = "Ice Beam", Value = 58  },
                    new { Text = "Ice Burn", Value = 554  },
                    new { Text = "Ice Fang", Value = 423  },
                    new { Text = "Ice Punch", Value = 8  },
                    new { Text = "Ice Shard", Value = 420  },
                    new { Text = "Icicle Crash", Value = 556  },
                    new { Text = "Icicle Spear", Value = 333  },
                    new { Text = "Icy Wind", Value = 196  },
                    new { Text = "Imprison", Value = 286  },
                    new { Text = "Incinerate", Value = 510  },
                    new { Text = "Inferno", Value = 517  },
                    new { Text = "Ingrain", Value = 275  },
                    new { Text = "Iron Defense", Value = 334  },
                    new { Text = "Iron Head", Value = 442  },
                    new { Text = "Iron Tail", Value = 231  },
                    new { Text = "Judgment", Value = 449  },
                    new { Text = "Jump Kick", Value = 26  },
                    new { Text = "Karate Chop", Value = 2  },
                    new { Text = "Kinesis", Value = 134  },
                    new { Text = "Knock Off", Value = 282  },
                    new { Text = "Last Resort", Value = 387  },
                    new { Text = "Lava Plume", Value = 436  },
                    new { Text = "Leaf Blade", Value = 348  },
                    new { Text = "Leaf Storm", Value = 437  },
                    new { Text = "Leaf Tornado", Value = 536  },
                    new { Text = "Leech Life", Value = 141  },
                    new { Text = "Leech Seed", Value = 73  },
                    new { Text = "Leer", Value = 43  },
                    new { Text = "Lick", Value = 122  },
                    new { Text = "Light Screen", Value = 113  },
                    new { Text = "Lock-On", Value = 199  },
                    new { Text = "Lovely Kiss", Value = 142  },
                    new { Text = "Low Kick", Value = 67  },
                    new { Text = "Low Sweep", Value = 490  },
                    new { Text = "Lucky Chant", Value = 381  },
                    new { Text = "Lunar Dance", Value = 461  },
                    new { Text = "Luster Purge", Value = 295  },
                    new { Text = "Mach Punch", Value = 183  },
                    new { Text = "Magic Coat", Value = 277  },
                    new { Text = "Magic Room", Value = 478  },
                    new { Text = "Magical Leaf", Value = 345  },
                    new { Text = "Magma Storm", Value = 463  },
                    new { Text = "Magnet Bomb", Value = 443  },
                    new { Text = "Magnet Rise", Value = 393  },
                    new { Text = "Magnitude", Value = 222  },
                    new { Text = "Me First", Value = 382  },
                    new { Text = "Mean Look", Value = 212  },
                    new { Text = "Meditate", Value = 96  },
                    new { Text = "Mega Drain", Value = 72  },
                    new { Text = "Mega Kick", Value = 25  },
                    new { Text = "Mega Punch", Value = 5  },
                    new { Text = "Megahorn", Value = 224  },
                    new { Text = "Memento", Value = 262  },
                    new { Text = "Metal Burst", Value = 368  },
                    new { Text = "Metal Claw", Value = 232  },
                    new { Text = "Metal Sound", Value = 319  },
                    new { Text = "Meteor Mash", Value = 309  },
                    new { Text = "Metronome", Value = 118  },
                    new { Text = "Milk Drink", Value = 208  },
                    new { Text = "Mimic", Value = 102  },
                    new { Text = "Mind Reader", Value = 170  },
                    new { Text = "Minimize", Value = 107  },
                    new { Text = "Miracle Eye", Value = 357  },
                    new { Text = "Mirror Coat", Value = 243  },
                    new { Text = "Mirror Move", Value = 119  },
                    new { Text = "Mirror Shot", Value = 429  },
                    new { Text = "Mist", Value = 54  },
                    new { Text = "Mist Ball", Value = 296  },
                    new { Text = "Moonlight", Value = 236  },
                    new { Text = "Morning Sun", Value = 234  },
                    new { Text = "Mud Bomb", Value = 426  },
                    new { Text = "Mud Shot", Value = 341  },
                    new { Text = "Mud Sport", Value = 300  },
                    new { Text = "Muddy Water", Value = 330  },
                    new { Text = "Mud-Slap", Value = 189  },
                    new { Text = "Nasty Plot", Value = 417  },
                    new { Text = "Natural Gift", Value = 363  },
                    new { Text = "Nature Power", Value = 267  },
                    new { Text = "Needle Arm", Value = 302  },
                    new { Text = "Night Daze", Value = 539  },
                    new { Text = "Night Shade", Value = 101  },
                    new { Text = "Night Slash", Value = 400  },
                    new { Text = "Nightmare", Value = 171  },
                    new { Text = "Octazooka", Value = 190  },
                    new { Text = "Odor Sleuth", Value = 316  },
                    new { Text = "Ominous Wind", Value = 466  },
                    new { Text = "Outrage", Value = 200  },
                    new { Text = "Overheat", Value = 315  },
                    new { Text = "Pain Split", Value = 220  },
                    new { Text = "Pay Day", Value = 6  },
                    new { Text = "Payback", Value = 371  },
                    new { Text = "Peck", Value = 64  },
                    new { Text = "Perish Song", Value = 195  },
                    new { Text = "Petal Dance", Value = 80  },
                    new { Text = "Pin Missile", Value = 42  },
                    new { Text = "Pluck", Value = 365  },
                    new { Text = "Poison Fang", Value = 305  },
                    new { Text = "Poison Gas", Value = 139  },
                    new { Text = "Poison Jab", Value = 398  },
                    new { Text = "Poison Powder", Value = 77  },
                    new { Text = "Poison Sting", Value = 40  },
                    new { Text = "Poison Tail", Value = 342  },
                    new { Text = "Pound", Value = 1  },
                    new { Text = "Powder Snow", Value = 181  },
                    new { Text = "Power Gem", Value = 408  },
                    new { Text = "Power Split", Value = 471  },
                    new { Text = "Power Swap", Value = 384  },
                    new { Text = "Power Trick", Value = 379  },
                    new { Text = "Power Whip", Value = 438  },
                    new { Text = "Present", Value = 217  },
                    new { Text = "Protect", Value = 182  },
                    new { Text = "Psybeam", Value = 60  },
                    new { Text = "Psych Up", Value = 244  },
                    new { Text = "Psychic", Value = 94  },
                    new { Text = "Psycho Boost", Value = 354  },
                    new { Text = "Psycho Cut", Value = 427  },
                    new { Text = "Psycho Shift", Value = 375  },
                    new { Text = "Psyshock", Value = 473  },
                    new { Text = "Psystrike", Value = 540  },
                    new { Text = "Psywave", Value = 149  },
                    new { Text = "Punishment", Value = 386  },
                    new { Text = "Pursuit", Value = 228  },
                    new { Text = "Quash", Value = 511  },
                    new { Text = "Quick Attack", Value = 98  },
                    new { Text = "Quick Guard", Value = 501  },
                    new { Text = "Quiver Dance", Value = 483  },
                    new { Text = "Rage", Value = 99  },
                    new { Text = "Rage Powder", Value = 476  },
                    new { Text = "Rain Dance", Value = 240  },
                    new { Text = "Rapid Spin", Value = 229  },
                    new { Text = "Razor Leaf", Value = 75  },
                    new { Text = "Razor Shell", Value = 534  },
                    new { Text = "Razor Wind", Value = 13  },
                    new { Text = "Recover", Value = 105  },
                    new { Text = "Recycle", Value = 278  },
                    new { Text = "Reflect", Value = 115  },
                    new { Text = "Reflect Type", Value = 513  },
                    new { Text = "Refresh", Value = 287  },
                    new { Text = "Relic Song", Value = 547  },
                    new { Text = "Rest", Value = 156  },
                    new { Text = "Retaliate", Value = 514  },
                    new { Text = "Return", Value = 216  },
                    new { Text = "Revenge", Value = 279  },
                    new { Text = "Reversal", Value = 179  },
                    new { Text = "Roar", Value = 46  },
                    new { Text = "Roar of Time", Value = 459  },
                    new { Text = "Rock Blast", Value = 350  },
                    new { Text = "Rock Climb", Value = 431  },
                    new { Text = "Rock Polish", Value = 397  },
                    new { Text = "Rock Slide", Value = 157  },
                    new { Text = "Rock Smash", Value = 249  },
                    new { Text = "Rock Throw", Value = 88  },
                    new { Text = "Rock Tomb", Value = 317  },
                    new { Text = "Rock Wrecker", Value = 439  },
                    new { Text = "Role Play", Value = 272  },
                    new { Text = "Rolling Kick", Value = 27  },
                    new { Text = "Rollout", Value = 205  },
                    new { Text = "Roost", Value = 355  },
                    new { Text = "Round", Value = 496  },
                    new { Text = "Sacred Fire", Value = 221  },
                    new { Text = "Sacred Sword", Value = 533  },
                    new { Text = "Safeguard", Value = 219  },
                    new { Text = "Sand Attack", Value = 28  },
                    new { Text = "Sand Tomb", Value = 328  },
                    new { Text = "Sandstorm", Value = 201  },
                    new { Text = "Scald", Value = 503  },
                    new { Text = "Scary Face", Value = 184  },
                    new { Text = "Scratch", Value = 10  },
                    new { Text = "Screech", Value = 103  },
                    new { Text = "Searing Shot", Value = 545  },
                    new { Text = "Secret Power", Value = 290  },
                    new { Text = "Secret Sword", Value = 548  },
                    new { Text = "Seed Bomb", Value = 402  },
                    new { Text = "Seed Flare", Value = 465  },
                    new { Text = "Seismic Toss", Value = 69  },
                    new { Text = "Self-Destruct", Value = 120  },
                    new { Text = "Shadow Ball", Value = 247  },
                    new { Text = "Shadow Claw", Value = 421  },
                    new { Text = "Shadow Force", Value = 467  },
                    new { Text = "Shadow Punch", Value = 325  },
                    new { Text = "Shadow Sneak", Value = 425  },
                    new { Text = "Sharpen", Value = 159  },
                    new { Text = "Sheer Cold", Value = 329  },
                    new { Text = "Shell Smash", Value = 504  },
                    new { Text = "Shift Gear", Value = 508  },
                    new { Text = "Shock Wave", Value = 351  },
                    new { Text = "Signal Beam", Value = 324  },
                    new { Text = "Silver Wind", Value = 318  },
                    new { Text = "Simple Beam", Value = 493  },
                    new { Text = "Sing", Value = 47  },
                    new { Text = "Sketch", Value = 166  },
                    new { Text = "Skill Swap", Value = 285  },
                    new { Text = "Skull Bash", Value = 130  },
                    new { Text = "Sky Attack", Value = 143  },
                    new { Text = "Sky Drop", Value = 507  },
                    new { Text = "Sky Uppercut", Value = 327  },
                    new { Text = "Slack Off", Value = 303  },
                    new { Text = "Slam", Value = 21  },
                    new { Text = "Slash", Value = 163  },
                    new { Text = "Sleep Powder", Value = 79  },
                    new { Text = "Sleep Talk", Value = 214  },
                    new { Text = "Sludge", Value = 124  },
                    new { Text = "Sludge Bomb", Value = 188  },
                    new { Text = "Sludge Wave", Value = 482  },
                    new { Text = "Smack Down", Value = 479  },
                    new { Text = "Smelling Salts", Value = 265  },
                    new { Text = "Smog", Value = 123  },
                    new { Text = "Smokescreen", Value = 108  },
                    new { Text = "Snarl", Value = 555  },
                    new { Text = "Snatch", Value = 289  },
                    new { Text = "Snore", Value = 173  },
                    new { Text = "Soak", Value = 487  },
                    new { Text = "Soft-Boiled", Value = 135  },
                    new { Text = "Solar Beam", Value = 76  },
                    new { Text = "Sonic Boom", Value = 49  },
                    new { Text = "Spacial Rend", Value = 460  },
                    new { Text = "Spark", Value = 209  },
                    new { Text = "Spider Web", Value = 169  },
                    new { Text = "Spike Cannon", Value = 131  },
                    new { Text = "Spikes", Value = 191  },
                    new { Text = "Spit Up", Value = 255  },
                    new { Text = "Spite", Value = 180  },
                    new { Text = "Splash", Value = 150  },
                    new { Text = "Spore", Value = 147  },
                    new { Text = "Stealth Rock", Value = 446  },
                    new { Text = "Steamroller", Value = 537  },
                    new { Text = "Steel Wing", Value = 211  },
                    new { Text = "Stockpile", Value = 254  },
                    new { Text = "Stomp", Value = 23  },
                    new { Text = "Stone Edge", Value = 444  },
                    new { Text = "Stored Power", Value = 500  },
                    new { Text = "Storm Throw", Value = 480  },
                    new { Text = "Strength", Value = 70  },
                    new { Text = "String Shot", Value = 81  },
                    new { Text = "Struggle", Value = 165  },
                    new { Text = "Struggle Bug", Value = 522  },
                    new { Text = "Stun Spore", Value = 78  },
                    new { Text = "Submission", Value = 66  },
                    new { Text = "Substitute", Value = 164  },
                    new { Text = "Sucker Punch", Value = 389  },
                    new { Text = "Sunny Day", Value = 241  },
                    new { Text = "Super Fang", Value = 162  },
                    new { Text = "Superpower", Value = 276  },
                    new { Text = "Supersonic", Value = 48  },
                    new { Text = "Surf", Value = 57  },
                    new { Text = "Swagger", Value = 207  },
                    new { Text = "Swallow", Value = 256  },
                    new { Text = "Sweet Kiss", Value = 186  },
                    new { Text = "Sweet Scent", Value = 230  },
                    new { Text = "Swift", Value = 129  },
                    new { Text = "Switcheroo", Value = 415  },
                    new { Text = "Swords Dance", Value = 14  },
                    new { Text = "Synchronoise", Value = 485  },
                    new { Text = "Synthesis", Value = 235  },
                    new { Text = "Tackle", Value = 33  },
                    new { Text = "Tail Glow", Value = 294  },
                    new { Text = "Tail Slap", Value = 541  },
                    new { Text = "Tail Whip", Value = 39  },
                    new { Text = "Tailwind", Value = 366  },
                    new { Text = "Take Down", Value = 36  },
                    new { Text = "Taunt", Value = 269  },
                    new { Text = "Techno Blast", Value = 546  },
                    new { Text = "Teeter Dance", Value = 298  },
                    new { Text = "Telekinesis", Value = 477  },
                    new { Text = "Teleport", Value = 100  },
                    new { Text = "Thief", Value = 168  },
                    new { Text = "Thrash", Value = 37  },
                    new { Text = "Thunder", Value = 87  },
                    new { Text = "Thunder Fang", Value = 422  },
                    new { Text = "Thunder Punch", Value = 9  },
                    new { Text = "Thunder Shock", Value = 84  },
                    new { Text = "Thunder Wave", Value = 86  },
                    new { Text = "Thunderbolt", Value = 85  },
                    new { Text = "Tickle", Value = 321  },
                    new { Text = "Torment", Value = 259  },
                    new { Text = "Toxic", Value = 92  },
                    new { Text = "Toxic Spikes", Value = 390  },
                    new { Text = "Transform", Value = 144  },
                    new { Text = "Tri Attack", Value = 161  },
                    new { Text = "Trick", Value = 271  },
                    new { Text = "Trick Room", Value = 433  },
                    new { Text = "Triple Kick", Value = 167  },
                    new { Text = "Trump Card", Value = 376  },
                    new { Text = "Twineedle", Value = 41  },
                    new { Text = "Twister", Value = 239  },
                    new { Text = "Uproar", Value = 253  },
                    new { Text = "U-turn", Value = 369  },
                    new { Text = "Vacuum Wave", Value = 410  },
                    new { Text = "V-create", Value = 557  },
                    new { Text = "Venoshock", Value = 474  },
                    new { Text = "Vice Grip", Value = 11  },
                    new { Text = "Vine Whip", Value = 22  },
                    new { Text = "Vital Throw", Value = 233  },
                    new { Text = "Volt Switch", Value = 521  },
                    new { Text = "Volt Tackle", Value = 344  },
                    new { Text = "Wake-Up Slap", Value = 358  },
                    new { Text = "Water Gun", Value = 55  },
                    new { Text = "Water Pledge", Value = 518  },
                    new { Text = "Water Pulse", Value = 352  },
                    new { Text = "Water Sport", Value = 346  },
                    new { Text = "Water Spout", Value = 323  },
                    new { Text = "Waterfall", Value = 127  },
                    new { Text = "Weather Ball", Value = 311  },
                    new { Text = "Whirlpool", Value = 250  },
                    new { Text = "Whirlwind", Value = 18  },
                    new { Text = "Wide Guard", Value = 469  },
                    new { Text = "Wild Charge", Value = 528  },
                    new { Text = "Will-O-Wisp", Value = 261  },
                    new { Text = "Wing Attack", Value = 17  },
                    new { Text = "Wish", Value = 273  },
                    new { Text = "Withdraw", Value = 110  },
                    new { Text = "Wonder Room", Value = 472  },
                    new { Text = "Wood Hammer", Value = 452  },
                    new { Text = "Work Up", Value = 526  },
                    new { Text = "Worry Seed", Value = 388  },
                    new { Text = "Wrap", Value = 35  },
                    new { Text = "Wring Out", Value = 378  },
                    new { Text = "X-Scissor", Value = 404  },
                    new { Text = "Yawn", Value = 281  },
                    new { Text = "Zap Cannon", Value = 192  },
                    new { Text = "Zen Headbutt", Value = 428  },
            };

            // Initialize Fields
            ComboBox[] box = cbtable();
            for (int i = 0; i < box.Length; i++)
            {
                box[i].DataSource = new BindingSource(move_list, null);
                box[i].DisplayMember = "Text";
                box[i].ValueMember = "Value";
            }

            C_Species.DataSource = species_list;
            C_Species.DisplayMember = "Text";
            C_Species.ValueMember = "Value";
        }
        private void loaddata()
        {
            for (int j=0; j<650; j++)
            {
                FileStream InStream = File.OpenRead(filepaths[j]);
                BinaryReader br = new BinaryReader(InStream);
                
                for (int i = 0; i < br.BaseStream.Length; i+=2)
                {
                    data[j,i/2]=(int)(br.ReadByte() + (br.ReadByte())*0x100);
                }
                br.Close();
            }
            C_Species.Enabled = true;
            TC.Enabled = true;
            L_Moves.Visible = true;
            filldata();
        }
        private void savedata()
        {
            for (int j = 0; j < 650; j++)
            {
                // Package up the Mart File
                byte[] buff = { (byte)(data[j, 0] & 0xFF), (byte)(data[j, 0] >> 8) }; // Total Moves
                for (int i=1; i<21; i++)
                {
                    if (data[j, i] > 0) // Make sure that it's not just blank.
                    {
                        byte[] a = { (byte)(data[j, i] & 0xFF), (byte)(data[j, i] >> 8) };
                        buff = buff.Concat(a).ToArray();
                    }
                }
                File.WriteAllBytes(filepaths[j],buff);
            }
        }
        private void filldata()
        {
            filling = true;
            L_Moves.Text = "Total Moves: " + data[(int)(getspecies()), 0];
            ComboBox[] box = cbtable();
            for (int i = 1; i < 21; i++)
            {
                box[i-1].SelectedValue = data[getspecies(),i];
            }
            filling = false;
        }
        private void reset()
        {
            int[,] data = new int[650, 21];
            ComboBox[] box = cbtable();
            for (int i = 1; i < 21; i++)
            {
                box[i - 1].SelectedValue = 0;
            }
            filldata();
        }

        private ComboBox[] cbtable()
        {
            ComboBox[] box = { C_Item1, C_Item2, C_Item3, C_Item4, C_Item5, C_Item6, C_Item7, C_Item8, C_Item9, C_Item10, C_Item11, C_Item12, C_Item13, C_Item14, C_Item15, C_Item16, C_Item17, C_Item18, C_Item19, C_Item20, };
            return box;
        }
        private int ToInt32(String value)
        {
            if (String.IsNullOrEmpty(value))
                return 0;
            return Int32.Parse(value);
        }
        private int getindex(ComboBox cb)
        {
            int val = 0;
            try { val = ToInt32(cb.SelectedValue.ToString()); }
            catch { };
            return val;
        }

        private void changespecies(object sender, EventArgs e)
        {
            filldata();
        }
        private void changeitem(object sender, EventArgs e)
        {
            if (!filling)
            {
                ComboBox[] box = cbtable();
                int count = 0;
                for (int i = 1; i < 21; i++)
                {
                    data[(int)(getspecies()), i] = getindex(box[i-1]);
                    if (getindex(box[i - 1]) > 0)
                    { count++; }
                }

                data[(getspecies()), 0] = count;
                L_Moves.Text = "Total Moves: " + count;
            }
        }
        private void B_Open_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog fbd = new FolderBrowserDialog();
            if (fbd.ShowDialog() == DialogResult.OK)
            {
                filepaths = Directory.GetFiles(fbd.SelectedPath, "*.*", SearchOption.AllDirectories);
                C_Species.SelectedIndex = 0;
                loaddata();
            }
            B_Save.Enabled = true;
        }
        private void B_Save_Click(object sender, EventArgs e)
        {
            try
            {
                savedata();
                MessageBox.Show("Data saved!");
            }
            catch (Exception ex)
            {
                string message = "Exception Error:\n\n" + ex + "\n\nFix this before saving.";
                string caption = "Error!";
                MessageBox.Show(message, caption);
            }
            reset();
            loaddata();
        }
    }
}
